// $Id: gucPrefDialog.js,v 1.2 2006/03/20 18:56:41 gramakri Exp $

/* Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Girish Ramakrishnan.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Girish Ramakrishnan <gramakri@uiuc.edu>
 *                        Tahera <taheraab@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 */

var gucPrefs = Components.classes["@mozilla.org/preferences-service;1"].
             getService(Components.interfaces.nsIPrefService).getBranch("guc.");

var observerService = Components.classes["@mozilla.org/observer-service;1"].
             getService(Components.interfaces.nsIObserverService);

var gAction = "";
var gEi = null;

function groupRules(event)
{
   document.getElementById('guc-context-menu-text').disabled = !event.target.checked;
}

function showInputDialog(title)
{
    document.getElementById("input-dialog").setAttribute("hidden", false);
    document.getElementById("input-dialog-caption").
             setAttribute("label", title + " rule");
    gAction = title;
    document.getElementById("add-rule").disabled = true;
    document.getElementById("edit-rule").disabled = true;
    document.getElementById("delete-rule").disabled = true;
}

function hideInputDialog()
{
    document.getElementById("input-dialog").setAttribute("hidden", true);
    document.getElementById("menutext-input").value = "";
    document.getElementById("searchpattern-input").value = "";
    document.getElementById("url-input").value = "";
    gAction = "";
    document.getElementById("add-rule").disabled = false;
    document.getElementById("edit-rule").disabled = false;
    document.getElementById("delete-rule").disabled = false;
}

function onAdd()
{
   showInputDialog("Add");
}

function onEdit()
{
    var tree = document.getElementById("guc-generic-url-list");
    if (tree.view.selection.currentIndex == -1) return;
    gEi = tree.contentView.getItemAtIndex(tree.view.selection.currentIndex);
    var si = gEi.firstChild.childNodes;
    document.getElementById("menutext-input").value =
                                        si.item(0).getAttribute("label");
    document.getElementById("searchpattern-input").value =
                                        si.item(1).getAttribute("label");
    document.getElementById("url-input").value = 
                                        si.item(2).getAttribute("label");
    showInputDialog("Edit");
}

function onDelete()
{
    var tree = document.getElementById("guc-generic-url-list");
    var selRow = tree.view.selection.currentIndex;
    if (selRow == -1) return;
    var treeChildren = tree.getElementsByTagName("treechildren").item(0);
    var ti = tree.contentView.getItemAtIndex(selRow);
    treeChildren.removeChild(ti);
    if (tree.view.rowCount !=0) {
        if (selRow == tree.view.rowCount) selRow--;
        tree.view.selection.select(selRow);
    }

}

function onOk()
{
   if (document.getElementById("menutext-input").value == "") {
          alert("Menu text cannot be empty");
          return;
   }
   var tree = document.getElementById("guc-generic-url-list");
   var treeChildren = tree.getElementsByTagName("treechildren").item(0);

   if (gAction == "Add") { 
        var tc1 = document.createElement("treecell");
        tc1.setAttribute("label",
              document.getElementById("menutext-input").value);
        var tc2 = document.createElement("treecell");
        tc2.setAttribute("label", 
              document.getElementById("searchpattern-input").value);
        var tc3 = document.createElement("treecell");
        tc3.setAttribute("label", 
              document.getElementById("url-input").value);
        var tr = document.createElement("treerow");
        var ti = document.createElement("treeitem");
        tr.appendChild(tc1);
        tr.appendChild(tc2);
        tr.appendChild(tc3);
        ti.appendChild(tr);
        var selRow = tree.view.selection.currentIndex;
        if (selRow == -1|| selRow == (tree.view.rowCount-1)) {
             treeChildren.appendChild(ti);
        } else {
             var nextRowItem = tree.contentView.getItemAtIndex(selRow+1);
            treeChildren.insertBefore(ti, nextRowItem);
        }
        tree.view.selection.select(selRow + 1);
   }
   else if (gAction == "Edit") {
        var si = gEi.firstChild.childNodes;
        si.item(0).setAttribute("label",
                              document.getElementById("menutext-input").value);
        si.item(1).setAttribute("label",
                              document.getElementById("searchpattern-input").value);
        si.item(2).setAttribute("label",
                              document.getElementById("url-input").value);
   }

   hideInputDialog();
}

function gucLoadSettings()
{
    var i = 1;
    var tree = document.getElementById("guc-generic-url-list");
    var treeChildren = tree.getElementsByTagName("treechildren").item(0);
    document.getElementById("guc-context-menu-text").
           setAttribute("value", gucPrefs.getCharPref("contextMenuText"));
    
    document.getElementById("chkGroupRules").addEventListener("CheckboxStateChange", groupRules, true);
    document.getElementById("chkGroupRules").checked = gucPrefs.getBoolPref("groupRules");
    
    while (true) {
        if (!gucPrefs.prefHasUserValue("menutext" + i)) break;
        if (gucPrefs.getCharPref("menutext" + i) == "") break;
        var tc1 = document.createElement("treecell");
        tc1.setAttribute("label", gucPrefs.getCharPref("menutext" + i));
        var tc2 = document.createElement("treecell");
        tc2.setAttribute("label", gucPrefs.getCharPref("searchpattern" + i));
        var tc3 = document.createElement("treecell");
        tc3.setAttribute("label", gucPrefs.getCharPref("url" + i));
         var tr = document.createElement("treerow");
        var ti = document.createElement("treeitem");
        tr.appendChild(tc1);
        tr.appendChild(tc2);
        tr.appendChild(tc3);
        ti.appendChild(tr);
        treeChildren.appendChild(ti);
        i = i + 1;
    }
    if (i > 0) tree.view.selection.select(0);
}

function gucSaveSettings()
{
    // clear the prefs in pref.js
    gucPrefs.deleteBranch("");

    if (document.getElementById("chkGroupRules").checked &&
        document.getElementById("guc-context-menu-text").value.length==0) {
        alert("Context Menu Text cannot be empty");
        return false;
    }

    var tree = document.getElementById("guc-generic-url-list");
    gucPrefs.setBoolPref("groupRules", document.getElementById("chkGroupRules").checked);
    gucPrefs.setCharPref("contextMenuText",
        document.getElementById("guc-context-menu-text").value);
    var i;
    for(i = 1; i<=tree.view.rowCount; i++) {
        var ti = tree.contentView.getItemAtIndex(i-1);
        var si = ti.firstChild.childNodes;
        gucPrefs.setCharPref("menutext"+i, si.item(0).getAttribute("label"));
        gucPrefs.setCharPref("searchpattern"+i, si.item(1).getAttribute("label"));
        gucPrefs.setCharPref("url"+i, si.item(2).getAttribute("label"));
    }
    
    // end of file
    gucPrefs.setCharPref("menutext"+i, "");
    gucPrefs.setCharPref("searchpattern"+i, "");
    gucPrefs.setCharPref("url"+i, "");

    observerService.notifyObservers(null, "guc-settings", "changed");

    return true;
}


function onMoveUp() 
{
    var tree = document.getElementById("guc-generic-url-list");
    var selRow = tree.view.selection.currentIndex;
     if (selRow != -1) {
        // if it isn't the first row
        if (selRow != 0) {
            var treeChildren = tree.getElementsByTagName("treechildren").item(0);
            var prevRowItem = tree.contentView.getItemAtIndex(selRow-1);
            var selRowItem = tree.contentView.getItemAtIndex(selRow);
            treeChildren.removeChild(selRowItem);
            treeChildren.insertBefore(selRowItem, prevRowItem);
            tree.view.selection.select(selRow-1);
        }
    }
}

function onMoveDown()
{
    var tree = document.getElementById("guc-generic-url-list");
    var selRow = tree.view.selection.currentIndex;
     if (selRow != -1) {
        // if it isn't the last row
        if (selRow != (tree.view.rowCount -1)) {
            var treeChildren = tree.getElementsByTagName("treechildren").item(0);
            var nextRowItem = tree.contentView.getItemAtIndex(selRow+1);
            var selRowItem = tree.contentView.getItemAtIndex(selRow);
            treeChildren.removeChild(nextRowItem);
            treeChildren.insertBefore(nextRowItem, selRowItem);
            tree.view.selection.select(selRow+1);
        }
    }
}

function restoreDefaults()
{
    //load the rules table with default rules
    var gucStringBundle = document.getElementById("guc_string_bundle");
    var tree = document.getElementById("guc-generic-url-list");
    var treeChildren = tree.getElementsByTagName("treechildren").item(0);
    document.getElementById("chkGroupRules").checked = true; // enabled by default
    document.getElementById("guc-context-menu-text").value =
        gucStringBundle.getString("guc.default.contextMenuText");
    
    // clear the tree
    tree.removeChild(treeChildren);
    //re-create
    treeChildren = document.createElement("treechildren");
    tree.appendChild(treeChildren);

    var i = 1;
    var mt = "";
    while (true) {
        try {
            mt = gucStringBundle.getString("guc.default.menutext" + i);   
        } catch (ex) {
            break;
        }
        if (mt == "") break;
        var tc1 = document.createElement("treecell");
        tc1.setAttribute("label", mt);
        var tc2 = document.createElement("treecell");
        tc2.setAttribute("label", gucStringBundle.getString("guc.default.searchpattern" + i));
        var tc3 = document.createElement("treecell");
        tc3.setAttribute("label", gucStringBundle.getString("guc.default.url" + i));
         var tr = document.createElement("treerow");
        var ti = document.createElement("treeitem");
        tr.appendChild(tc1);
        tr.appendChild(tc2);
        tr.appendChild(tc3);
        ti.appendChild(tr);
        treeChildren.appendChild(ti);
        i = i + 1;
    }
    if (i > 0) tree.view.selection.select(0);


}